//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_Help.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace App_help {
//---------------------------------------------------------------------------
const AnsiString THelpModel::HelpFile = ExtractFilePath(Application->ExeName) + "Help\\index.html";
const AnsiString THelpModel::About = "Execian Version 2.0.2\r\n\r\nCopyright (C) 2009-2012 Moochos. All rights reserved.";
//---------------------------------------------------------------------------
__fastcall THelpModel::THelpModel() :
	TObject()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall THelpModel::~THelpModel()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall THelpModel::ShowContents()
{
	if(Application->MessageBox(
		"The program opens the offline help.",
		Application->Title.c_str(),
		MB_OKCANCEL | MB_ICONWARNING | MB_SETFOREGROUND) != IDOK) {
		Abort();
	}
	SHELLEXECUTEINFO LExecuteInfo = {0};
	LExecuteInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	LExecuteInfo.fMask = SEE_MASK_FLAG_NO_UI;
	LExecuteInfo.lpVerb = "open";
	LExecuteInfo.lpFile = HelpFile.c_str();
	LExecuteInfo.nShow = SW_SHOWNORMAL;
	if(!ShellExecuteEx(&LExecuteInfo)) {
		throw EHelpError("The program could not open the help.");
	}
}
//---------------------------------------------------------------------------
void __fastcall THelpModel::ShowAbout()
{
	Application->MessageBox(
		About.c_str(),
		"About",
		MB_OK | MB_SETFOREGROUND);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
__fastcall THelpCommands::THelpCommands(THelpModel* AHelpModel) :
	TCommands(),
	FHelpModel(AHelpModel)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall THelpCommands::~THelpCommands()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall THelpCommands::ShowContents()
{
	if(!CanShowContents()) {
		HandleUnavailableFeature();
	}
	HelpModel->ShowContents();
}
//---------------------------------------------------------------------------
bool __fastcall THelpCommands::CanShowContents()
{
	return true;
}
//---------------------------------------------------------------------------
void __fastcall THelpCommands::ShowAbout()
{
	if(!CanShowAbout()) {
		HandleUnavailableFeature();
	}
	HelpModel->ShowAbout();
}
//---------------------------------------------------------------------------
bool __fastcall THelpCommands::CanShowAbout()
{
	return true;
}
//---------------------------------------------------------------------------
} // End namespace App_help
//---------------------------------------------------------------------------

