//---------------------------------------------------------------------------
#ifndef App_OpenH
#define App_OpenH
//---------------------------------------------------------------------------
#include "App_Commands.h"
#include "App_Documents.h"
#include "App_Programs.h"
//---------------------------------------------------------------------------
namespace App_open {
//---------------------------------------------------------------------------
class EOpenError : public Exception
{
public:
	__fastcall EOpenError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TOpenTask;
class TOpenModel : public TObject
{
private:
	TOpenTask* FTask;
	void __fastcall TaskTerminate(TObject* ASender);
	void __fastcall TaskProgress(TObject* ASender, int ACurrent, int AAll);
	void __fastcall TaskStatus(TObject* ASender, const AnsiString& AStatus);
	void __fastcall TaskNext(TObject* ASender);
	void __fastcall AppProgressDialogExecute(TObject* ASender);
	void __fastcall AppProgressDialogCancel(TObject* ASender);
	__property TOpenTask* Task = {read=FTask};
protected:
public:
	__fastcall TOpenModel();
	virtual __fastcall ~TOpenModel();
	virtual void __fastcall Perform(TProgramEntry* AProgramEntry, TDocumentModel* ADocumentModel);
};
//---------------------------------------------------------------------------
class TOpenCommands : public TCommands
{
private:
	TProgramModel* FProgramModel;
	TProgramSelections* FProgramSelections;
	TDocumentModel* FDocumentModel;
	TDocumentSelections* FDocumentSelections;
	TOpenModel* FOpenModel;
	__property TProgramModel* ProgramModel = {read=FProgramModel};
	__property TProgramSelections* ProgramSelections = {read=FProgramSelections};
	__property TDocumentModel* DocumentModel = {read=FDocumentModel};
	__property TDocumentSelections* DocumentSelections = {read=FDocumentSelections};
	__property TOpenModel* OpenModel = {read=FOpenModel};
protected:
public:
	__fastcall TOpenCommands(TProgramModel* AProgramModel, TProgramSelections* AProgramSelections, TDocumentModel* ADocumentModel, TDocumentSelections* ADocumentSelections, TOpenModel* AOpenModel);
	virtual __fastcall ~TOpenCommands();
	virtual void __fastcall Perform();
	virtual bool __fastcall CanPerform();
};
//---------------------------------------------------------------------------
} // End namespace App_open
using namespace App_open;
//---------------------------------------------------------------------------
#endif

