//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_ProgressDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAppProgressDialog* AppProgressDialog = NULL;
//---------------------------------------------------------------------------
namespace App_progressdialog {
//---------------------------------------------------------------------------
AnsiString __fastcall TAppProgressValues::GetProgram()
{
	return Owner->Label2->Caption;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressValues::SetProgram(const AnsiString& AProgram)
{
	Owner->Label2->Caption = AProgram;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAppProgressValues::GetDocument()
{
	return Owner->Label4->Caption;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressValues::SetDocument(const AnsiString& ADocument)
{
	Owner->Label4->Caption = ADocument;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAppProgressValues::GetStatus()
{
	return Owner->Label5->Caption;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressValues::SetStatus(const AnsiString& AStatus)
{
	Owner->Label5->Caption = AStatus;
}
//---------------------------------------------------------------------------
int __fastcall TAppProgressValues::GetCurrent()
{
	return Owner->ProgressBar1->Position;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressValues::SetCurrent(int ACurrent)
{
	Owner->ProgressBar1->Position = ACurrent;
}
//---------------------------------------------------------------------------
int __fastcall TAppProgressValues::GetAll()
{
	return Owner->ProgressBar1->Max;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressValues::SetAll(int AAll)
{
	Owner->ProgressBar1->Min = 0;
	Owner->ProgressBar1->Max = AAll;
}
//---------------------------------------------------------------------------
__fastcall TAppProgressValues::TAppProgressValues(TAppProgressDialog* AOwner) :
	TObject(),
	FOwner(AOwner)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TAppProgressValues::~TAppProgressValues()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressValues::Reset()
{
	Program = AnsiString();
	Document = AnsiString();
	Status = AnsiString();
	Current = 0;
	All = 100;
}
//---------------------------------------------------------------------------
} // End namespace App_progressdialog
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::Initialize()
{
	try {
		FValues = new TAppProgressValues(this);
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::Uninitialize()
{
	delete FValues;
	FValues = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::WMAppExecute(TMessage& AMessage)
{
	DoExecute();
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::DoExecute()
{
	if(OnExecute != NULL) {
		OnExecute(this);
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::DoCancel()
{
	if(OnCancel != NULL) {
		OnCancel(this);
	}
}
//---------------------------------------------------------------------------
__fastcall TAppProgressDialog::TAppProgressDialog(TComponent* AOwner) :
	TForm(AOwner),
	FValues(NULL),
	FOnExecute(NULL),
	FOnCancel(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TAppProgressDialog::~TAppProgressDialog()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
TAppProgressDialog* __fastcall TAppProgressDialog::EnsureCreated()
{
	if(AppProgressDialog == NULL) {
		AppProgressDialog = new TAppProgressDialog(Application);
	}
	return AppProgressDialog;
}
//---------------------------------------------------------------------------
bool __fastcall TAppProgressDialog::CloseQuery()
{
	if(ModalResult != mrOk) {
		DoCancel();
		return false;
	}
	return TForm::CloseQuery();
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::Execute()
{
	ActiveControl = NULL;
	SelectFirst();
	::PostMessage(Handle, WM_APP_EXECUTE, 0, 0);
	ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::Cancel()
{
	ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::Finish()
{
	ModalResult = mrOk;
}
//---------------------------------------------------------------------------

