//---------------------------------------------------------------------------
// Version: 1.0+1.0
// Date: 2012-04-03 UTC+09:00
// Version: 1.0.0
// Date: 2011-12-13 UTC+09:00
// Status: Beta
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Moa_Forms.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moa_forms {
//---------------------------------------------------------------------------
void __fastcall TUpdateNotifier::RemoveMessage(HWND AWindow, UINT AMessageType)
{
	MSG LMessage = {0};
	::PeekMessage(&LMessage, AWindow, AMessageType, AMessageType, PM_REMOVE);
}
//---------------------------------------------------------------------------
void __fastcall TUpdateNotifier::Initialize()
{
	try {
		FWindow = AllocateHWnd(HandleMessage);
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TUpdateNotifier::Uninitialize()
{
	if(FWindow != NULL) {
		DeallocateHWnd(FWindow);
		FWindow = NULL;
	}
}
//---------------------------------------------------------------------------
void __fastcall TUpdateNotifier::HandleMessage(TMessage& AMessage)
{
	if(AMessage.Msg == WM_APP_UPDATE) {
		Update();
	}
	else {
		AMessage.Result = ::DefWindowProc(Window, AMessage.Msg, AMessage.WParam, AMessage.LParam);
	}
}
//---------------------------------------------------------------------------
void __fastcall TUpdateNotifier::DoUpdate()
{
	if(OnUpdate != NULL) {
		OnUpdate(this);
	}
}
//---------------------------------------------------------------------------
__fastcall TUpdateNotifier::TUpdateNotifier() :
	TObject(),
	FWindow(NULL),
	FInvalidated(false),
	FOnUpdate(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TUpdateNotifier::~TUpdateNotifier()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TUpdateNotifier::Invalidate()
{
	if(Invalidated) {
		return;
	}
	;;PostMessage(Window, WM_APP_UPDATE, 0, 0);
	FInvalidated = true;
}
//---------------------------------------------------------------------------
void __fastcall TUpdateNotifier::Update()
{
	if(!Invalidated) {
		return;
	}
	FInvalidated = false;
	DoUpdate();
}
//---------------------------------------------------------------------------
void __fastcall TUpdateNotifier::Refresh()
{
	if(Invalidated) {
		RemoveMessage(Window, WM_APP_UPDATE);
		FInvalidated = false;
	}
	DoUpdate();
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
TRect __fastcall TFormUtilities::GetNormalBounds(TForm* AForm)
{
	return GetPlacement(AForm).rcNormalPosition;
}
//---------------------------------------------------------------------------
void __fastcall TFormUtilities::SetNormalBounds(TForm* AForm, const TRect& ABounds)
{
	WINDOWPLACEMENT LPlacement = GetPlacement(AForm);
	LPlacement.rcNormalPosition = ABounds;
	SetPlacement(AForm, LPlacement);
}
//---------------------------------------------------------------------------
TPoint __fastcall TFormUtilities::GetNormalPosition(TForm* AForm)
{
	WINDOWPLACEMENT LPlacement = GetPlacement(AForm);
	return TPoint(LPlacement.rcNormalPosition.left, LPlacement.rcNormalPosition.top);
}
//---------------------------------------------------------------------------
void __fastcall TFormUtilities::SetNormalPosition(TForm* AForm, const TPoint& APosition)
{
	WINDOWPLACEMENT LPlacement = GetPlacement(AForm);
	LPlacement.rcNormalPosition = Bounds(
		APosition.x,
		APosition.y,
		TRect(LPlacement.rcNormalPosition).Width(),
		TRect(LPlacement.rcNormalPosition).Height());
	SetPlacement(AForm, LPlacement);
}
//---------------------------------------------------------------------------
WINDOWPLACEMENT __fastcall TFormUtilities::GetPlacement(TForm* AForm)
{
	WINDOWPLACEMENT LPlacement = {0};
	LPlacement.length = sizeof(WINDOWPLACEMENT);
	if(!::GetWindowPlacement(AForm->Handle, &LPlacement)) {
		throw EInvalidOperation("The program could not get the placement of the form.");
	}
	return LPlacement;
}
//---------------------------------------------------------------------------
void __fastcall TFormUtilities::SetPlacement(TForm* AForm, const WINDOWPLACEMENT& APlacement)
{
	if(!::SetWindowPlacement(AForm->Handle, &APlacement)) {
		throw EInvalidOperation("The program could not set the placement of the form.");
	}
}
//---------------------------------------------------------------------------
} // End namespace Moa_forms
//---------------------------------------------------------------------------

