//---------------------------------------------------------------------------
// Version: 2.0.0
// Date: 2012-04-02 UTC+09:00
// Version: 1.0.0
// Date: 2011-08-26 UTC+09:00
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <Math.hpp>
#include "Moa_AutoPointers.h"
#include "Moa_DynamicArrays.h"
#include "Moa_Lists.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moa_lists {
//---------------------------------------------------------------------------
__fastcall TExchangeRecord::TExchangeRecord() :
	Index1(0),
	Index2(0)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TExchangeRecord::TExchangeRecord(int AIndex1, int AIndex2) :
	Index1(AIndex1),
	Index2(AIndex2)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TExchangeRecord::TExchangeRecord(const TExchangeRecord& ASource) :
	Index1(ASource.Index1),
	Index2(ASource.Index2)
{
	// Do nothing
}
//---------------------------------------------------------------------------
TExchangeRecord& __fastcall TExchangeRecord::operator =(const TExchangeRecord& ASource)
{
	if(&ASource == this) {
		return *this;
	}
	Index1 = ASource.Index1;
	Index2 = ASource.Index2;
	return *this;
}
//---------------------------------------------------------------------------
bool __fastcall TExchangeRecord::operator ==(const TExchangeRecord& AOther) const
{
	if(&AOther == this) {
		return true;
	}
	return
		Index1 == AOther.Index1 &&
		Index2 == AOther.Index2;
}
//---------------------------------------------------------------------------
bool __fastcall TExchangeRecord::operator !=(const TExchangeRecord& AOther) const
{
	return !(*this == AOther);
}
//---------------------------------------------------------------------------
TExchangeRecord& __fastcall TExchangeRecord::Reverse()
{
	int LBackup = Index1;
	Index1 = Index2;
	Index2 = LBackup;
	return *this;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
__fastcall TReorderRecord::TReorderRecord() :
	SourceIndex(0),
	DestinationIndex(0)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TReorderRecord::TReorderRecord(int ASourceIndex, int ADestinationIndex) :
	SourceIndex(ASourceIndex),
	DestinationIndex(ADestinationIndex)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TReorderRecord::TReorderRecord(const TReorderRecord& ASource) :
	SourceIndex(ASource.SourceIndex),
	DestinationIndex(ASource.DestinationIndex)
{
	// Do nothing
}
//---------------------------------------------------------------------------
TReorderRecord& __fastcall TReorderRecord::operator =(const TReorderRecord& ASource)
{
	if(&ASource == this) {
		return *this;
	}
	SourceIndex = ASource.SourceIndex;
	DestinationIndex = ASource.DestinationIndex;
	return *this;
}
//---------------------------------------------------------------------------
bool __fastcall TReorderRecord::operator ==(const TReorderRecord& AOther) const
{
	if(&AOther == this) {
		return true;
	}
	return
		SourceIndex == AOther.SourceIndex &&
		DestinationIndex == AOther.DestinationIndex;
}
//---------------------------------------------------------------------------
bool __fastcall TReorderRecord::operator !=(const TReorderRecord& AOther) const
{
	return !(*this == AOther);
}
//---------------------------------------------------------------------------
TReorderRecord& __fastcall TReorderRecord::Reverse()
{
	int LBackup = SourceIndex;
	SourceIndex = DestinationIndex;
	DestinationIndex = LBackup;
	return *this;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
int __fastcall TListAlgorithms::SortCompare(void* AItem1, void* AItem2)
{
	TSortRecord* LRecord1 = static_cast<TSortRecord*>(AItem1);
	TSortRecord* LRecord2 = static_cast<TSortRecord*>(AItem2);
	int LResult = LRecord1->Compare(LRecord1->Index, LRecord2->Index, LRecord1->Data);
	if(LResult == 0) {
		LResult = LRecord1->Index - LRecord2->Index;
	}
	return LResult;
}
//---------------------------------------------------------------------------
void __fastcall TListAlgorithms::Swap(int& AValue1, int& AValue2)
{
	int LBackup = AValue1;
	AValue1 = AValue2;
	AValue2 = LBackup;
}
//---------------------------------------------------------------------------
TReorderRecords __fastcall TListAlgorithms::Sort(int ACount, TSortCompare ACompare, void* AData)
{
	DynamicArray<TSortRecord> LSortRecords;
	LSortRecords.Length = ACount;
	for(int LI = 0; LI < LSortRecords.Length; ++LI) {
		LSortRecords[LI].Index = LI;
		LSortRecords[LI].Compare = ACompare;
		LSortRecords[LI].Data = AData;
	}
	TAutoPointer<TList> LTable = new TList();
	LTable->Count = ACount;
	for(int LI = 0; LI < LTable->Count; ++LI) {
		LTable->Items[LI] = &LSortRecords[LI];
	}
	LTable->Sort(&SortCompare);
	TReorderRecords LReorderRecords;
	{
		int LChangeCount = 0;
		for(int LI = 0; LI < LTable->Count; ++LI) {
			if(static_cast<TSortRecord*>(LTable->Items[LI])->Index == LI) {
				continue;
			}
			++LChangeCount;
		}
		LReorderRecords.Length = LChangeCount;
	}
	{
		int LChangeCount = 0;
		for(int LI = 0; LI < LTable->Count; ++LI) {
			if(static_cast<TSortRecord*>(LTable->Items[LI])->Index == LI) {
				continue;
			}
			LReorderRecords[LChangeCount].SourceIndex = static_cast<TSortRecord*>(LTable->Items[LI])->Index;
			LReorderRecords[LChangeCount].DestinationIndex = LI;
			++LChangeCount;
		}
	}
	return LReorderRecords;
}
//---------------------------------------------------------------------------
TReorderRecords __fastcall TListAlgorithms::Reverse(int ACount)
{
	TReorderRecords LReorderRecords;
	LReorderRecords.Length = ACount;
	for(int LI = 0; LI < LReorderRecords.Length; ++LI) {
		LReorderRecords[LI].SourceIndex = LI;
		LReorderRecords[LI].DestinationIndex = LReorderRecords.Length - 1 - LI;
	}
	return LReorderRecords;
}
//---------------------------------------------------------------------------
TReorderRecords __fastcall TListAlgorithms::Slide(int ACount, const TIntegerDynArray& AIndexes, int AStep)
{
	if(ACount == 0 || AIndexes.Length == 0 || AIndexes.Length == ACount || AStep == 0) {
		return TReorderRecords();
	}
	int LMinIndex = AIndexes[0];
	int LMaxIndex = AIndexes[0];
	for(int LI = 0; LI < AIndexes.Length; ++LI) {
		LMinIndex = Math::Min(LMinIndex, AIndexes[LI]);
		LMaxIndex = Math::Max(LMaxIndex, AIndexes[LI]);
	}
	int LStartIndex = LMinIndex;
	int LEndIndex = LMaxIndex;
	if(AStep < 0) {
		LStartIndex = Math::Max(
			static_cast<__int64>(LMinIndex) + AStep,
			static_cast<__int64>(0));
	}
	else {
		LEndIndex = Math::Min(
			static_cast<__int64>(LMaxIndex) + AStep,
			static_cast<__int64>(ACount - 1));
	}
	DynamicArray<TSlideRecord> LRecords;
	LRecords.Length = LEndIndex - LStartIndex + 1;
	for(int LI = 0; LI < LRecords.Length; ++LI) {
		LRecords[LI].Index = LStartIndex + LI;
		LRecords[LI].Target = false;
	}
	for(int LI = 0; LI < AIndexes.Length; ++LI) {
		LRecords[AIndexes[LI] - LStartIndex].Target = true;
	}
	TAutoPointer<TList> LTable = new TList();
	LTable->Count = LRecords.Length;
	for(int LI = 0; LI < LTable->Count; ++LI) {
		LTable->Items[LI] = &LRecords[LI];
	}
	{
		int LSourceStep;
		int LSourceIndex;
		int LMoveStep;
		int LMoveCount;
		if(AStep < 0) {
			LSourceStep = 1;
			LSourceIndex = LMinIndex - LStartIndex - LSourceStep;
			LMoveStep = -1;
			LMoveCount = -AStep;
		}
		else {
			LSourceStep = -1;
			LSourceIndex = LMaxIndex - LStartIndex - LSourceStep;
			LMoveStep = 1;
			LMoveCount = AStep;
		}
		for(int LI = 0; LI < LMaxIndex - LMinIndex + 1; ++LI) {
			LSourceIndex += LSourceStep;
			if(!static_cast<TSlideRecord*>(LTable->Items[LSourceIndex])->Target) {
				continue;
			}
			int LDestinationIndex = LSourceIndex;
			for(int LJ = 0; LJ < LMoveCount; ++LJ) {
				LDestinationIndex += LMoveStep;
				if(
					LDestinationIndex == -1 ||
					LDestinationIndex == LTable->Count ||
					static_cast<TSlideRecord*>(LTable->Items[LDestinationIndex])->Target) {
					LDestinationIndex -= LMoveStep;
					break;
				}
			}
			LTable->Move(LSourceIndex, LDestinationIndex);
		}
	}
	TReorderRecords LReorderRecords;
	{
		int LChangeCount = 0;
		for(int LI = 0; LI < LTable->Count; ++LI) {
			if(static_cast<TSlideRecord*>(LTable->Items[LI])->Index == LStartIndex + LI) {
				continue;
			}
			++LChangeCount;
		}
		LReorderRecords.Length = LChangeCount;
	}
	{
		int LChangeCount = 0;
		for(int LI = 0; LI < LTable->Count; ++LI) {
			if(static_cast<TSlideRecord*>(LTable->Items[LI])->Index == LStartIndex + LI) {
				continue;
			}
			LReorderRecords[LChangeCount].SourceIndex = static_cast<TSlideRecord*>(LTable->Items[LI])->Index;
			LReorderRecords[LChangeCount].DestinationIndex = LStartIndex + LI;
			++LChangeCount;
		}
	}
	return LReorderRecords;
}
//---------------------------------------------------------------------------
TExchangeRecords __fastcall TListAlgorithms::ReverseExchangeRecords(const TExchangeRecords& ARecords)
{
	TExchangeRecords LRecords;
	LRecords.Length = ARecords.Length;
	for(int LI = 0; LI < LRecords.Length; ++LI) {
		LRecords[LI] = TExchangeRecord(ARecords[LRecords.High - LI]).Reverse();
	}
	return LRecords;
}
//---------------------------------------------------------------------------
TReorderRecords __fastcall TListAlgorithms::ExchangeRecordsToReorderRecords(const TExchangeRecords& ARecords)
{
	if(ARecords.Length == 0) {
		return TReorderRecords();
	}
	int LMinIndex = ARecords[0].Index1;
	int LMaxIndex = ARecords[0].Index1;
	for(int LI = 0; LI < ARecords.Length; ++LI) {
		LMinIndex = Math::Min(LMinIndex, ARecords[LI].Index1);
		LMinIndex = Math::Min(LMinIndex, ARecords[LI].Index2);
		LMaxIndex = Math::Max(LMaxIndex, ARecords[LI].Index1);
		LMaxIndex = Math::Max(LMaxIndex, ARecords[LI].Index2);
	}
	TIntegerDynArray LTable;
	LTable.Length = LMaxIndex - LMinIndex + 1;
	for(int LI = 0; LI < LTable.Length; ++LI) {
		LTable[LI] = LMinIndex + LI;
	}
	for(int LI = 0; LI < ARecords.Length; ++LI) {
		Swap(LTable[ARecords[LI].Index1 - LMinIndex], LTable[ARecords[LI].Index2 - LMinIndex]);
	}
	TAutoPointer<TDynamicArrayBuilder<TReorderRecord> > LBuilder = new TDynamicArrayBuilder<TReorderRecord>();
	{
		int LChangeCount = 0;
		for(int LI = 0; LI < LTable.Length; ++LI) {
			if(LTable[LI] == LMinIndex + LI) {
				continue;
			}
			++LChangeCount;
		}
		LBuilder->Capacity = LChangeCount * 2;
	}
	for(int LI = 0; LI < LTable.Length; ++LI) {
		if(LTable[LI] == LMinIndex + LI) {
			continue;
		}
		LBuilder->Add(TReorderRecord(LMinIndex + LI, LMinIndex + LTable[LI]));
		LBuilder->Add(TReorderRecord(LMinIndex + LTable[LI], LMinIndex + LI));
	}
	return TDynamicArrayUtilities<TReorderRecord>::Reverse(LBuilder->Finish());
}
//---------------------------------------------------------------------------
TReorderRecords __fastcall TListAlgorithms::ReverseReorderRecords(const TReorderRecords& ARecords)
{
	TReorderRecords LRecords;
	LRecords.Length = ARecords.Length;
	for(int LI = 0; LI < LRecords.Length; ++LI) {
		LRecords[LI] = TReorderRecord(ARecords[LRecords.High - LI]).Reverse();
	}
	return LRecords;
}
//---------------------------------------------------------------------------
TExchangeRecords __fastcall TListAlgorithms::ReorderRecordsToExchangeRecords(const TReorderRecords& ARecords)
{
	if(ARecords.Length == 0) {
		return TExchangeRecords();
	}
	int LMinIndex = ARecords[0].SourceIndex;
	int LMaxIndex = ARecords[0].SourceIndex;
	for(int LI = 0; LI < ARecords.Length; ++LI) {
		LMinIndex = Math::Min(LMinIndex, ARecords[LI].SourceIndex);
		LMinIndex = Math::Min(LMinIndex, ARecords[LI].DestinationIndex);
		LMaxIndex = Math::Max(LMaxIndex, ARecords[LI].SourceIndex);
		LMaxIndex = Math::Max(LMaxIndex, ARecords[LI].DestinationIndex);
	}
	TIntegerDynArray LTable;
	LTable.Length = LMaxIndex - LMinIndex + 1;
	for(int LI = 0; LI < LTable.Length; ++LI) {
		LTable[LI] = LMinIndex + LI;
	}
	for(int LI = 0; LI < ARecords.Length; ++LI) {
		LTable[ARecords[LI].DestinationIndex - LMinIndex] = ARecords[LI].SourceIndex - LMinIndex;
	}
	TAutoPointer<TDynamicArrayBuilder<TExchangeRecord> > LBuilder = new TDynamicArrayBuilder<TExchangeRecord>();
	LBuilder->Capacity = LTable.Length;
	for(int LI = 0; LI < LTable.Length; ++LI) {
		if(LTable[LI] == LI) {
			continue;
		}
		LBuilder->Add(TExchangeRecord(LMinIndex + LI, LMinIndex + LTable[LI]));
		Swap(LTable[LI], LTable[LTable[LI]]);
		--LI;
	}
	return TDynamicArrayUtilities<TExchangeRecord>::Reverse(LBuilder->Finish());
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TListUtilities::InsertItems(TList* AList, const TIntegerDynArray& AIndexes)
{
	for(int LI = 0; LI < AIndexes.Length; ++LI) {
		AList->Insert(AIndexes[LI], NULL);
	}
}
//---------------------------------------------------------------------------
void __fastcall TListUtilities::InsertSucceedingItems(TList* AList, int AIndex, int ACount)
{
	for(int LI = 0; LI < ACount; ++LI) {
		AList->Insert(AIndex + LI, NULL);
	}
}
//---------------------------------------------------------------------------
void __fastcall TListUtilities::DeleteItems(TList* AList, const TIntegerDynArray& AIndexes)
{
	for(int LI = 0; LI < AIndexes.Length; ++LI) {
		AList->Delete(AIndexes[AIndexes.High - LI]);
	}
}
//---------------------------------------------------------------------------
void __fastcall TListUtilities::DeleteSucceedingItems(TList* AList, int AIndex, int ACount)
{
	for(int LI = 0; LI < ACount; ++LI) {
		AList->Delete(AIndex + ACount - 1 - LI);
	}
}
//---------------------------------------------------------------------------
void __fastcall TListUtilities::ExchangeItems(TList* AList, const TExchangeRecords& ARecords)
{
	for(int LI = 0; LI < ARecords.Length; ++LI) {
		AList->Exchange(ARecords[LI].Index1, ARecords[LI].Index2);
	}
}
//---------------------------------------------------------------------------
void __fastcall TListUtilities::Reorder(TList* AList, const TReorderRecords& ARecords)
{
	TAutoPointer<TList> LList = new TList();
	LList->Count = ARecords.Length;
	for(int LI = 0; LI < LList->Count; ++LI) {
		LList->Items[LI] = AList->Items[ARecords[LI].SourceIndex];
	}
	for(int LI = 0; LI < LList->Count; ++LI) {
		AList->Items[ARecords[LI].DestinationIndex] = LList->Items[LI];
	}
}
//---------------------------------------------------------------------------
void __fastcall TListUtilities::Reverse(TList* AList)
{
	for(int LI = 0; LI < AList->Count / 2; ++LI) {
		AList->Exchange(LI, AList->Count - 1 - LI);
	}
}
//---------------------------------------------------------------------------
void* __fastcall TListUtilities::Replace(TList* AList, int AIndex, void* AItem)
{
	void* LItem = AList->Items[AIndex];
	AList->Items[AIndex] = AItem;
	return LItem;
}
//---------------------------------------------------------------------------
void __fastcall TListUtilities::EnsureCapacity(TList* AList, int ACapacity)
{
	if(AList->Capacity < ACapacity) {
		AList->Capacity = ACapacity;
	}
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TObjectListUtilities::Reorder(TObjectList* AList, const TReorderRecords& ARecords)
{
	bool LObjectsOwned = AList->OwnsObjects;
	AList->OwnsObjects = false;
	try {
		Reorder(static_cast<TList*>(AList), ARecords);
	}
	catch(...) {
		AList->OwnsObjects = LObjectsOwned;
		throw;
	}
	AList->OwnsObjects = LObjectsOwned;
}
//---------------------------------------------------------------------------
TObject* __fastcall TObjectListUtilities::Replace(TObjectList* AList, int AIndex, TObject* AItem)
{
	TObject* LItem;
	bool LObjectsOwned = AList->OwnsObjects;
	AList->OwnsObjects = false;
	try {
		LItem = static_cast<TObject*>(Replace(static_cast<TList*>(AList), AIndex, AItem));
	}
	catch(...) {
		AList->OwnsObjects = LObjectsOwned;
		throw;
	}
	AList->OwnsObjects = LObjectsOwned;
	return LItem;
}
//---------------------------------------------------------------------------
} // End namespace Moa_lists
//---------------------------------------------------------------------------

